using System;
using System.Drawing;
using System.Windows.Forms;
using J4L.RSS;
using System.Drawing.Printing;

	public class RSSExamples : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnExit;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox comboExample;
		private System.Windows.Forms.Label lblDescription;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnPrint;
		
		
		private BarCode bc=null;
		private PrintDocument printDocument1;	
		
		public RSSExamples()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			setBarcodeComponent(0);
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnPrint = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblDescription = new System.Windows.Forms.Label();
			this.comboExample = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnExit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(112, 360);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.TabIndex = 6;
			this.btnPrint.Text = "Print";
			this.btnPrint.Click += new System.EventHandler(this.BtnPrintClick);
			// 
			// panel1
			// 
			this.panel1.Location = new System.Drawing.Point(24, 56);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 264);
			this.panel1.TabIndex = 2;
			// 
			// lblDescription
			// 
			this.lblDescription.Location = new System.Drawing.Point(32, 328);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(504, 24);
			this.lblDescription.TabIndex = 5;
			this.lblDescription.Text = "description";
			// 
			// comboExample
			// 
			this.comboExample.Items.AddRange(new object[] {
						"UPC E",
						"UPC E with 2D Component",
						"EAN 8",
						"EAN 8 with 2D Component",
						"EAN 13",
						"EAN 13 with 2D Component",
						"UPC A",
						"UPC A with 2D Component",
						"EAN 128",
						"EAN 128 with 2D Component",
						"RSS14",
						"RSS14 Stacked",
						"RSS14 Truncated",
						"RSS14 Stacked Omnnidirectional",
						"RSS14 Stacked with 2D Component",
						"RSS Limited",
						"RSS Limited with 2D Component",
						"RSS Expanded",
						"RSS Expanded Stacked",
						"RSS Expanded with 2D Component",
						"RSS Expanded Stacked with 2D Component"});
			this.comboExample.Location = new System.Drawing.Point(136, 24);
			this.comboExample.Name = "comboExample";
			this.comboExample.Size = new System.Drawing.Size(408, 21);
			this.comboExample.TabIndex = 1;
			this.comboExample.Text = "UPC E";
			this.comboExample.SelectedIndexChanged += new System.EventHandler(this.ComboExampleSelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 24);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Select example";
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(24, 360);
			this.btnSave.Name = "btnSave";
			this.btnSave.TabIndex = 3;
			this.btnSave.Text = "Save GIF";
			this.btnSave.Click += new System.EventHandler(this.BtnSaveClick);
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(200, 360);
			this.btnExit.Name = "btnExit";
			this.btnExit.TabIndex = 4;
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.BtnExitClick);
			// 
			// RSSExamples
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(560, 390);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.comboExample);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblDescription);
			this.Name = "RSSExamples";
			this.Text = "RSS and EAN-UCC Composite Examples";
			this.ResumeLayout(false);
		}
		#endregion
		void ComboExampleSelectedIndexChanged(object sender, System.EventArgs e)
		{
			setBarcodeComponent(comboExample.SelectedIndex);
		}
		
		void BtnSaveClick(object sender, System.EventArgs e)
		{
			bc.saveToFile("barcode.gif","GIF");
			MessageBox.Show("Barcode saved to barcode.gif");			
		}
		
		void BtnExitClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
		private void printDocument1_PrintPage(object sender, 
			System.Drawing.Printing.PrintPageEventArgs e)
			{
   				//e.Graphics.FillRectangle(Brushes.Red, 
     			//new Rectangle(500, 500, 500, 500));
				
				bc.paint(e.Graphics);
				
			}		
		

  /**
   * create examples
   */
  private void setBarcodeComponent(int index) {

   	panel1.SuspendLayout();
   	if (bc!=null) panel1.Controls.Remove(bc);

    switch (index) {
    case 0:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.UPCE;
      this.bc.Code="012000001239";
      this.lblDescription.Text="UPCE barcode encodes 012000001239";
      break;
    case 1:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.UPCE;
      this.bc.Code="012000001239";
      this.bc.SecondaryCode="15021231";
      this.lblDescription.Text="UPCE barcode encodes 012000001239 and 2D Component encodes 15021231";
      break;
    case 2:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN8;
      this.bc.Code="12345670";
      this.lblDescription.Text="EAN8 barcode encodes 12345670";
      break;
    case 3:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN8;
      this.bc.Code="12345670";
      this.bc.SecondaryCode="21A12345678";
      this.lblDescription.Text="EAN8 barcode encodes 12345670 and 2D Component encodes 21A12345678";
      break;
    case 4:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN13;
      this.bc.Code="3312345678903";
      this.lblDescription.Text="EAN13 barcode encodes 3312345678903";
      break;
    case 5:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN13;
      this.bc.Code="3312345678903";
      this.bc.SecondaryCode="991234-abcd";
      this.lblDescription.Text="EAN13 barcode encodes 3312345678903 and 2D Component encodes 991234-abcd";
      break;
    case 6:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.UPCA;
      this.bc.Code="31234567890";
      this.lblDescription.Text="UPCA barcode encodes 31234567890";
      break;
    case 7:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.UPCA;
      this.bc.Code="31234567890";
      this.bc.SecondaryCode="991234-abcd";
      this.lblDescription.Text="UPCA barcode encodes 31234567890 and 2D Component encodes 991234-abcd";
      break;
    case 8:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN128;
      this.bc.Code="0103212345678906";
      this.bc.HumanReadableCode="(01)03212345678906";
      this.lblDescription.Text="EAN128 barcode encodes 0103212345678906";
      break;
    case 9:
      this.bc=new BarCode();
      this.bc.Symbology=BarCode.EAN128;
      this.bc.Code="0193812345678901";
      this.bc.HumanReadableCode="(01)93812345678901";
      this.bc.SecondaryCode="10ABCD123456#4103898765432108";
      this.lblDescription.Text="EAN128 barcode encodes 0193812345678901 and 2D Component encodes 10ABCD123456#4103898765432108";
      break;
    case 10:
      this.bc=new RSS14();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_REGULAR;
      this.bc.Code="0361234567890";
      this.lblDescription.Text="RSS14 barcode encodes 0361234567890";
      break;
    case 11:
      this.bc=new RSS14();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_STACKED;
      this.bc.Code="0341234567890";
      this.lblDescription.Text="RSS14 stacked barcode encodes 0341234567890";
      break;
    case 12:
      this.bc=new RSS14();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_TRUNCATED;
      this.bc.Code="0341234567890";
      this.lblDescription.Text="RSS14 truncated barcode encodes 0341234567890";
      break;

    case 13:
      this.bc=new RSS14();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_STACKED_OMNIDIRECTIONAL;
      this.bc.Code="2001234567890";
      this.lblDescription.Text="RSS14 stacked omnidirectional barcode encodes 2001234567890";
      break;

    case 14:
      this.bc=new RSS14();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_STACKED;
      this.bc.Code="0341234567890";
      this.bc.SecondaryCode="17010200";
      this.lblDescription.Text="RSS14 stacked barcode encodes 0341234567890  and 2D Component encodes 17010200";
      break;

    case 15:
      this.bc=new RSSLimited();
      this.bc.Code="0031234567890";
      this.lblDescription.Text="RSS limited barcode encodes 0031234567890";
      break;

    case 16:
      this.bc=new RSSLimited();
      this.bc.Code="1311234567890";
      this.bc.SecondaryCode="1701061510A123456";
      this.lblDescription.Text="RSS limited  barcode encodes 1311234567890  and 2D Component encodes 1701061510A123456";
      break;

    case 17:
      this.bc=new RSSExpanded();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_EXPANDED;
      this.bc.Code="01937123456789043103001234";
      this.lblDescription.Text="RSS14 expanded barcode encodes 01937123456789043103001234";
      break;

    case 18:
      this.bc=new RSSExpanded();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_EXPANDED_STACKED;
      this.bc.Code="010001234567890510ABCDEF";
      this.lblDescription.Text="RSS14 expanded stacked barcode encodes 010001234567890510ABCDEF";
      break;

    case 19:
      this.bc=new RSSExpanded();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_EXPANDED;
      this.bc.Code="01937123456789043103001234";
      this.bc.SecondaryCode="911A2B3C4D5E";
      this.lblDescription.Text="RSS14 expanded barcode encodes 01937123456789043103001234  and 2D Component encodes 911A2B3C4D5E";
      break;

    case 20:
      this.bc=new RSSExpanded();
      ((RSS14) this.bc).RSSFormat=RSS14.FORMAT_EXPANDED_STACKED;
      this.bc.Code="010001234567890510ABCDEF";
      this.bc.SecondaryCode="2112345678";
      this.lblDescription.Text="RSS14 expanded stacked barcode encodes 010001234567890510ABCDEF  and 2D Component encodes 2112345678";
      break;
   } // switch

    this.bc.LeftMargin=20;
    this.bc.TopMargin=20;
    
	this.bc.Location = new System.Drawing.Point(8, 8);
	this.bc.Name = "bc";
	this.bc.Size = new System.Drawing.Size(300, 300);
	this.bc.TabIndex = 0;    
    
    panel1.Controls.Add(this.bc);
    panel1.ResumeLayout(false);

  }
		
			
	public static void Main(string[] args)
	{
	Application.Run(new RSSExamples());
      
      /*BarCode bc=new BarCode();
      bc.Symbology=BarCode.EAN128;
      bc.Code="0193812345678901";
      bc.HumanReadableCode="(01)93812345678901";*/
      
      
      /* BarCode bc=new RSS14();
      ((RSS14) bc).RSSFormat=RSS14.FORMAT_REGULAR;
      bc.Code="0361234567890";      
      bc.leftMargin=20;
      bc.saveToFile("bar.gif","GIF");*/

	}		
		
	void BtnPrintClick(object sender, System.EventArgs e)
	{
			printDocument1=new PrintDocument();
			this.printDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument1_PrintPage);			
			printDocument1.Print();
					
	}
	
}
